/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is hultmann localization tools.
 *
 * The Initial Developer of the Original Code is
 * Jeferson Hultmann <hultmann@gmail.com>
 * Portions created by the Initial Developer are Copyright (C) 2005
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either of the GNU General Public License Version 2 or later (the "GPL"),
 * or the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

using System.Collections.Generic;
using System.Text.RegularExpressions;

namespace LocaleInpector
{

internal sealed class EntityTest : PhraseTest
{

private static readonly string[] m_exc = new string[] { "&amp;", "&nbsp;", "&quot;", "&gt;", "&lt;", "&apos;" };
//private static readonly string   m_entityExpression = @"&[a-zA-Z0-9\._]*;";

private static Regex m_regex = new Regex(@"&[a-zA-Z0-9\._]*;");

public override string Compare(Dictionary<string, string>.Enumerator originalEntry, string translated)
{
    //string original = originalEntry.Current.Value;
    //if (MatchRegex(m_regex, original, translated, m_exc) == false) {
    string err = CompareCore(originalEntry.Current.Value, translated);
    if (err != null) {
        m_stat.Errors++;
        return err;
    }
    return null;
}


public static string CompareCore(string original, string translated)
{
    if (MatchRegex(m_regex, original, translated, m_exc)) {
        return null;
    } else {
        return "different entities";
    }
}


public static bool HasEntity(string txt)
{
    //Regex regex = new Regex(m_entityExpression);
    MatchCollection matches = m_regex.Matches(txt);
    return matches.Count > 0;
}

}//class
}//ns


